## aflplusplus 4.00c

=== Makefile ===
all:
	@echo trying to use GNU make...
	@gmake all || echo please install GNUmake

source-only:
	@gmake source-only

binary-only:
	@gmake binary-only

distrib:
	@gmake distrib

man:
	@gmake man

install:
	@gmake install

document:
	@gmake document

deepclean:
	@gmake deepclean

code-format:
	@gmake code-format

help:
	@gmake help

tests:
	@gmake tests

unit:
	@gmake unit

unit_clean:
	@gmake unit_clean

clean:
	@gmake clean

=== qemu_mode/libqasan/Makefile ===
#
# american fuzzy lop++ - libqasan
# -------------------------------
#
# Written by Andrea Fioraldi <andreafioraldi@gmail.com>
#
# Copyright 2019-2022 Andrea Fioraldi. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

PREFIX      ?= /usr/local
HELPER_PATH  = $(PREFIX)/lib/afl
DOC_PATH    ?= $(PREFIX)/share/doc/afl
MAN_PATH    ?= $(PREFIX)/share/man/man8

VERSION     = $(shell grep '^\#define VERSION ' ../config.h | cut -d '"' -f2)

CFLAGS      += -I ../qemuafl/qemuafl/
CFLAGS      += -Wno-int-to-void-pointer-cast -ggdb
LDFLAGS     += -ldl -pthread

SRC := libqasan.c hooks.c malloc.c string.c uninstrument.c patch.c dlmalloc.c
HDR := libqasan.h

all: libqasan.so

libqasan.so: $(HDR) $(SRC)
	$(CC) $(CFLAGS) -fPIC -shared $(SRC) -o ../../$@ $(LDFLAGS)

.NOTPARALLEL: clean

clean:
	rm -f *.o *.so *~ a.out core core.[1-9][0-9]*
	rm -f ../../libqasan.so

install: all
	install -m 755 ../../libqasan.so $${DESTDIR}$(HELPER_PATH)
	install -m 644 -T README.md $${DESTDIR}$(DOC_PATH)/README.qasan.md

=== qemu_mode/unsigaction/Makefile ===
#
# american fuzzy lop++ - unsigaction
# --------------------------------
#
# Written by Andrea Fioraldi <andreafioraldi@gmail.com>
#
# Copyright 2019-2022 Andrea Fioraldi. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
.POSIX:

_UNIQ=_QINU_

TARGETCANDIDATES=unsigaction.so
_TARGETS=$(_UNIQ)$(AFL_NO_X86)$(_UNIQ)
__TARGETS=$(_TARGETS:$(_UNIQ)1$(_UNIQ)=)
TARGETS=$(__TARGETS:$(_UNIQ)$(_UNIQ)=$(TARGETCANDIDATES))

all:  $(TARGETS)

unsigaction.so: unsigaction.c
	@if $(CC) -fPIC -shared unsigaction.c -o unsigaction.so 2>/dev/null ; then echo "unsigaction build success"; else echo "unsigaction build failure (that's fine)"; fi

clean:
	rm -f unsigaction.so

=== utils/afl_untracer/Makefile ===
ifdef DEBUG
  OPT=-O0
else
  OPT=-O3
endif

all:	afl-untracer libtestinstr.so

afl-untracer:	afl-untracer.c
	$(CC) $(OPT) -I../../include -g -o afl-untracer afl-untracer.c -ldl

libtestinstr.so:	libtestinstr.c
	$(CC) -g -O0 -fPIC -o libtestinstr.so -shared libtestinstr.c

clean:
	rm -f afl-untracer libtestinstr.so *~ core

=== utils/argv_fuzzing/Makefile ===
#
# american fuzzy lop++ - argvfuzz
# --------------------------------
#
# Copyright 2019-2022 Kjell Braden <afflux@pentabarf.de>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

.PHONY: all install clean

PREFIX     ?= /usr/local
BIN_PATH    = $(PREFIX)/bin
HELPER_PATH = $(PREFIX)/lib/afl

CFLAGS = -fPIC -Wall -Wextra
LDFLAGS = -shared

UNAME_SAYS_LINUX=$(shell uname | grep -E '^Linux|^GNU' >/dev/null; echo $$?)
UNAME_SAYS_LINUX:sh=uname | grep -E '^Linux|^GNU' >/dev/null; echo $$?

_LDFLAGS_ADD=$(UNAME_SAYS_LINUX:1=)
LDFLAGS_ADD=$(_LDFLAGS_ADD:0=-ldl)
LDFLAGS  += $(LDFLAGS_ADD)

# on gcc for arm there is no -m32, but -mbe32
M32FLAG = -m32
M64FLAG = -m64

CC_IS_GCC=$(shell $(CC) --version 2>/dev/null | grep -q gcc; echo $$?)
CC_IS_GCC:sh=$(CC) --version 2>/dev/null | grep -q gcc; echo $$?
CC_IS_ARMCOMPILER=$(shell $(CC) -v 2>&1 >/dev/null | grep -q arm; echo $$?)
CC_IS_ARMCOMPILER:sh=$(CC) -v 2>&1 >/dev/null | grep -q arm; echo $$?

_M32FLAG=$(CC_IS_GCC)$(CC_IS_ARMCOMPILER)
__M32FLAG=$(_M32FLAG:00=-mbe32)
___M32FLAG=$(__M32FLAG:$(CC_IS_GCC)$(CC_IS_ARMCOMPILER)=-m32)
M32FLAG=$(___M32FLAG)

all: argvfuzz32.so argvfuzz64.so

argvfuzz32.so: argvfuzz.c
	-@$(CC) $(M32FLAG) $(CFLAGS) $^ $(LDFLAGS) -o $@ 2>/dev/null || echo "argvfuzz32 build failure (that's fine)"

argvfuzz64.so: argvfuzz.c
	-@$(CC) $(M64FLAG) $(CFLAGS) $^ $(LDFLAGS) -o $@ 2>/dev/null || echo "argvfuzz64 build failure (that's fine)"

install: argvfuzz32.so argvfuzz64.so
	install -d -m 755 $(DESTDIR)$(HELPER_PATH)/
	if [ -f argvfuzz32.so ]; then set -e; install -m 755 argvfuzz32.so $(DESTDIR)$(HELPER_PATH)/; fi
	if [ -f argvfuzz64.so ]; then set -e; install -m 755 argvfuzz64.so $(DESTDIR)$(HELPER_PATH)/; fi

clean:
	rm -f argvfuzz32.so argvfuzz64.so

=== utils/libdislocator/Makefile ===
#
# american fuzzy lop++ - libdislocator
# ----------------------------------
#
# Originally written by Michal Zalewski
#
# Copyright 2016 Google Inc. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

PREFIX      ?= /usr/local
HELPER_PATH  = $(PREFIX)/lib/afl

VERSION     = $(shell grep '^\#define VERSION ' ../../config.h | cut -d '"' -f2)

CFLAGS      ?= -O3 -funroll-loops -D_FORTIFY_SOURCE=2
override CFLAGS += -I ../../include/ -Wall -g -Wno-pointer-sign

CFLAGS_ADD=$(USEHUGEPAGE:1=-DUSEHUGEPAGE)
CFLAGS += $(CFLAGS_ADD)

all: libdislocator.so

libdislocator.so: libdislocator.so.c ../../config.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -shared -fPIC libdislocator.so.c -o $@ $(LDFLAGS)
	cp -fv libdislocator.so ../../

.NOTPARALLEL: clean

clean:
	rm -f *.o *.so *~ a.out core core.[1-9][0-9]*
	rm -f ../../libdislocator.so

install: all
	install -m 755 -d $${DESTDIR}$(HELPER_PATH)
	install -m 755 ../../libdislocator.so $${DESTDIR}$(HELPER_PATH)
	install -m 644 -T README.md $${DESTDIR}$(HELPER_PATH)/README.dislocator.md

=== utils/optimin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(optimin
    LANGUAGES CXX
    DESCRIPTION "MaxSAT-based fuzzing corpus minimizer"
)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")

# Add LLVM
find_package(LLVM REQUIRED CONFIG)
message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION}")

include_directories(${LLVM_INCLUDE_DIRS})
add_definitions(${LLVM_DEFINITIONS} -DNDEBUG)

add_subdirectory(EvalMaxSAT)
add_subdirectory(src)

=== utils/socket_fuzzing/Makefile ===
#
# american fuzzy lop++ - socket_fuzz
# ----------------------------------
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

.PHONY: all install clean

PREFIX     ?= /usr/local
BIN_PATH    = $(PREFIX)/bin
HELPER_PATH = $(PREFIX)/lib/afl

CFLAGS = -fPIC -Wall -Wextra
LDFLAGS = -shared

UNAME_SAYS_LINUX=$(shell uname | grep -E '^Linux|^GNU' >/dev/null; echo $$?)
UNAME_SAYS_LINUX:sh=uname | grep -E '^Linux|^GNU' >/dev/null; echo $$?

_LDFLAGS_ADD=$(UNAME_SAYS_LINUX:1=)
LDFLAGS_ADD=$(_LDFLAGS_ADD:0=-ldl)
LDFLAGS  += $(LDFLAGS_ADD)

# on gcc for arm there is no -m32, but -mbe32
M32FLAG = -m32
M64FLAG = -m64

CC_IS_GCC=$(shell $(CC) --version 2>/dev/null | grep -q gcc; echo $$?)
CC_IS_GCC:sh=$(CC) --version 2>/dev/null | grep -q gcc; echo $$?
CC_IS_ARMCOMPILER=$(shell $(CC) -v 2>&1 >/dev/null | grep -q arm; echo $$?)
CC_IS_ARMCOMPILER:sh=$(CC) -v 2>&1 >/dev/null | grep -q arm; echo $$?

_M32FLAG=$(CC_IS_GCC)$(CC_IS_ARMCOMPILER)
__M32FLAG=$(_M32FLAG:00=-mbe32)
___M32FLAG=$(__M32FLAG:$(CC_IS_GCC)$(CC_IS_ARMCOMPILER)=-m32)
M32FLAG=$(___M32FLAG)
#ifeq "$(findstring clang, $(shell $(CC) --version 2>/dev/null))" ""
# ifneq (,$(findstring arm, "$(shell $(CC) -v 2>&1 >/dev/null)"))
#  M32FLAG = -mbe32
# endif
#endif

all: socketfuzz32.so socketfuzz64.so

socketfuzz32.so: socketfuzz.c
	-@$(CC) $(M32FLAG) $(CFLAGS) $^ $(LDFLAGS) -o $@ 2>/dev/null || echo "socketfuzz32 build failure (that's fine)"

socketfuzz64.so: socketfuzz.c
	-@$(CC) $(M64FLAG) $(CFLAGS) $^ $(LDFLAGS) -o $@ 2>/dev/null || echo "socketfuzz64 build failure (that's fine)"

install: socketfuzz32.so socketfuzz64.so
	install -d -m 755 $(DESTDIR)$(HELPER_PATH)/
	if [ -f socketfuzz32.so ]; then set -e; install -m 755 socketfuzz32.so $(DESTDIR)$(HELPER_PATH)/; fi
	if [ -f socketfuzz64.so ]; then set -e; install -m 755 socketfuzz64.so $(DESTDIR)$(HELPER_PATH)/; fi

clean:
	rm -f socketfuzz32.so socketfuzz64.so

=== frida_mode/test/cmplog/Makefile ===
all:
	@echo trying to use GNU make...
	@gmake all || echo please install GNUmake

32:
	@echo trying to use GNU make...
	@gmake 32 || echo please install GNUmake

clean:
	@gmake clean

qemu:
	@gmake qemu

frida:
	@gmake frida


frida-nocmplog:
	@gmake frida-nocmplog

format:
	@gmake format

debug:
	@gmake debug

=== unicorn_mode/samples/c/Makefile ===
# UnicornAFL Usage
# Original Unicorn Example Makefile by Nguyen Anh Quynh <aquynh@gmail.com>, 2015
# Adapted for AFL++ by domenukk <domenukk@gmail.com>, 2020
.POSIX:
UNAME_S =$(shell uname -s)# GNU make
UNAME_S:sh=uname -s       # BSD make

UNICORNAFL_LIB = ../../unicornafl/build
UNICORN_LIB = ../../unicornafl/unicorn/build
BIN_EXT =
AR_EXT = a

# Verbose output?
V ?= 0

CFLAGS += -Wall -Werror -I../../unicornafl/unicorn/include -I../../unicornafl/include

LDFLAGS += -L$(UNICORNAFL_LIB) -L$(UNICORN_LIB) -lpthread -lm -lunicornafl -lunicorn -lc++

ifeq ($(UNAME), Linux)
# do something Linux-y
LRT = -lrt
else
LRT = 
endif

LDFLAGS += $(LRT)

.PHONY: all clean

all: harness

clean:
	rm -rf *.o harness harness-debug

harness.o: harness.c ../../unicornafl/unicorn/include/unicorn/*.h
	${CC} ${CFLAGS} -O3 -c harness.c

harness-debug.o: harness.c ../../unicornafl/unicorn/include/unicorn/*.h
	${CC} ${CFLAGS} -g -c harness.c -o $@

../../unicornafl/build/libunicornafl.a:
	cd ../.. && ./build_unicorn_support.sh

harness: harness.o
	${CC} harness.o ../../unicornafl/build/libunicornafl.a $(LDFLAGS) -o $@

debug: harness-debug.o
	${CC} harness.o ../../unicornafl/build/libunicornafl.a $(LDFLAGS) -o harness-debug

fuzz: harness
	DYLD_FALLBACK_LIBRARY_PATH="../../unicornafl/unicorn/build" LD_LIBRARY_PATH="../../unicornafl/unicorn/build" ../../../afl-fuzz -m none -i sample_inputs -o out -- ./harness @@

=== unicorn_mode/samples/persistent/Makefile ===
# UnicornAFL Usage
# Original Unicorn Example Makefile by Nguyen Anh Quynh <aquynh@gmail.com>, 2015
# Adapted for AFL++ by domenukk <domenukk@gmail.com>, 2020
.POSIX:
UNAME_S =$(shell uname -s)# GNU make
UNAME_S:sh=uname -s       # BSD make

UNICORNAFL_LIB = ../../unicornafl/build
UNICORN_LIB = ../../unicornafl/unicorn/build
BIN_EXT =
AR_EXT = a

# Verbose output?
V ?= 0

CFLAGS += -Wall -Werror -I../../unicornafl/unicorn/include -I../../unicornafl/include

LDFLAGS += -L$(UNICORNAFL_LIB) -L$(UNICORN_LIB) -lpthread -lm -lunicornafl -lunicorn -lc++

ifeq ($(UNAME), Linux)
# do something Linux-y
LRT = -lrt
else
LRT = 
endif

LDFLAGS += $(LRT)

.PHONY: all clean

all: harness

clean:
	rm -rf *.o harness harness-debug

harness.o: harness.c ../../unicornafl/unicorn/include/unicorn/*.h
	${CC} ${CFLAGS} -O3 -c harness.c

harness-debug.o: harness.c ../../unicornafl/unicorn/include/unicorn/*.h
	${CC} ${CFLAGS} -DAFL_DEBUG=1 -g -c harness.c -o $@

harness: harness.o
	${CC} harness.o ../../unicornafl/build/libunicornafl.a $(LDFLAGS) -o $@

debug: harness-debug.o
	${CC} harness-debug.o ../../unicornafl/build/libunicornafl.a $(LDFLAGS) -o harness-debug

../../unicornafl/build/libunicornafl.a:
	cd ../.. && ./build_unicorn_support.sh

fuzz: harness
	DYLD_FALLBACK_LIBRARY_PATH="../../unicornafl/unicorn/build" LD_LIBRARY_PATH="../../unicornafl/unicorn/build" ../../../afl-fuzz -m none -i sample_inputs -o out -- ./harness @@

debugmake:
	@echo UNAME_S=$(UNAME_S), _LRT=$(_LRT), __LRT=$(__LRT), LRT=$(LRT)

=== utils/optimin/src/CMakeLists.txt ===
add_executable(optimin OptiMin.cpp)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")

foreach(LIB MaLib EvalMaxSAT glucose)
    target_include_directories(optimin PRIVATE
        "${CMAKE_SOURCE_DIR}/EvalMaxSAT/lib/${LIB}/src")
    target_link_libraries(optimin ${LIB})
endforeach(LIB)

llvm_map_components_to_libnames(LLVM_LIBS support)
target_link_libraries(optimin ${LLVM_LIBS})

install(TARGETS optimin RUNTIME DESTINATION bin)

=== debian/changelog ===
aflplusplus (4.00c-1ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Increase test-custom-mutators timeouts to avoid
      FTBFS on arm64 amd armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 23 Feb 2022 17:23:37 +0100

aflplusplus (4.00c-1) unstable; urgency=medium

  * Switch to llvm-toolchain-13 (Closes: #1004881)
  * New upstream version 4.00c
  * Update debian/copyright
  * Refresh the patch
  * Update doc installation
  * Update lintian-overrides
  * Add a patch to fix spelling errors

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 07 Feb 2022 14:54:56 +0100

aflplusplus (3.14c-2ubuntu1) jammy; urgency=medium

  * Increase test-custom-mutators timeouts to avoid
    FTBFS on arm64 amd armhf

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 02 Feb 2022 15:53:26 +0000

aflplusplus (3.14c-2build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 14 Jan 2022 11:24:00 +0000

aflplusplus (3.14c-2) unstable; urgency=medium

  * Add correctly the helper-scripts afl-clang and afl-clang++ (issue with
    upstream .gitignore)

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 15 Sep 2021 09:06:42 +0200

aflplusplus (3.14c-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints. + afl++-doc: Add Multi-Arch: foreign.

  [ Sophie Brun ]
  * New upstream version 3.14c
  * Add missing dependency procps to afl++
  * Add new build-dep: gcc-10-plugin-dev
  * Update debian/copyright
  * debian/rules: update build for new release
  * Add build-deps for tests: clang and libcmocka-dev
  * Install all files in afl-++. afl++-clang is now a transitional package.
  * debian/rules: no need to remove non -fast binaries
  * Add a patch to fix the failing test
  * Update debian/afl++-clang.lintian-overrides
  * Bump Standards-Version to 4.6.0 (no change)
  * Add scripts for deprecated afl-clang and afl-clang++ with specific clang version
  * Use clang and llvm version 12

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 14 Sep 2021 08:41:43 +0200

=== debian/control ===
Source: aflplusplus
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders:
 Sophie Brun <sophie@offensive-security.com>,
 Raphaël Hertzog <raphael@offensive-security.com>
Build-Depends:
 clang-13,
 debhelper-compat (= 13),
 dh-buildinfo,
 gcc-10-plugin-dev (>= 10.2.1-16),
 llvm-13-dev,
 python3-dev,
# for the tests
 clang,
 libcmocka-dev
Standards-Version: 4.6.0
Homepage: https://github.com/vanhauser-thc/AFLplusplus
Vcs-Git: https://salsa.debian.org/pkg-security-team/aflplusplus.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/aflplusplus

Package: afl++
Architecture: any
Depends: build-essential,
         procps,
         clang-${llvm-major-version},
	 clang,
	 ${misc:Depends},
	 ${shlibs:Depends}
Recommends: afl++-doc
Suggests: gnuplot
Breaks: afl (<< 2.53c), afl++-clang (<< 3.14c)
Replaces: afl (<< 2.53c), afl++-clang (<< 3.14c)
Description: instrumentation-driven fuzzer for binary formats
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary. This substantially
 improves the functional coverage for the fuzzed code. The compact synthesized
 corpora produced by the tool are also useful for seeding other, more labor- or
 resource-intensive testing regimes down the road.
 .
 afl++-fuzz is designed to be practical: it has modest performance
 overhead, uses a variety of highly effective fuzzing strategies, requires
 essentially no configuration, and seamlessly handles complex, real-world use
 cases - say, common image parsing or file compression libraries.
 .
 afl++ is a fork of the unmaintained afl.

Package: afl++-clang
Architecture: any
Section: oldlibs
Depends: afl++,
         ${misc:Depends}
Recommends: afl++-doc
Breaks: afl-clang (<< 2.53c)
Replaces: afl-clang (<< 2.53c)
Description: transitional dummy package for afl++-clang to afl++
 This is a transitional package. It can safely be removed once afl++ is
 installed.

Package: afl++-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: afl++
Multi-Arch: foreign
Description: instrumentation-driven fuzzer for binary formats - documentation
 American fuzzy lop is a fuzzer that employs compile-time instrumentation and
 genetic algorithms to automatically discover clean, interesting test cases
 that trigger new internal states in the targeted binary.
 .
 This package provides the documentation, a collection of special crafted test
 cases, vulnerability samples and experimental stuff.

Package: afl
Architecture: all
Section: oldlibs
Depends: ${misc:Depends}, afl++
Description: transitional dummy package for afl to afl++
 This is a transitional package. It can safely be removed once afl++ is
 installed.

Package: afl-clang
Architecture: all
Section: oldlibs
Depends: ${misc:Depends}, afl++-clang
Description: transitional dummy package for afl-clang to afl++-clang
 This is a transitional package. It can safely be removed once afl++-clang is
 installed.

Package: afl-doc
Architecture: all
Section: oldlibs
Depends: ${misc:Depends}, afl++-doc
Description: transitional dummy package for afl-doc to afl++-doc
 This is a transitional package. It can safely be removed once afl++-doc is
 installed.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# don't emit NEON instructions whatsoever to prevent FTBFS on machines which
# doesn't support that, see #842143 [thanks to Paul Wise]
ifeq "$(shell dpkg-architecture -q DEB_HOST_ARCH)" "armhf"
export DEB_CFLAGS_MAINT_APPEND = -mfpu=vfpv3
export DEB_CXXFLAGS_MAINT_APPEND = -mfpu=vfpv3
endif

export HOSTNAME =
export PREFIX = /usr

ifeq "$(filter i386 amd64,$(shell dpkg-architecture -q DEB_HOST_ARCH_CPU))" ""
export AFL_NO_X86 = 1
endif

# Keep this in sync with Build-Depends (clang-X, llvm-X-dev)
export LLVM_MAJOR_VERSION = 13
export LLVM_CONFIG = llvm-config-$(LLVM_MAJOR_VERSION)

%:
	dh $@ --with buildinfo

override_dh_auto_build:
	$(MAKE) distrib

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	rm $(CURDIR)/debian/tmp/usr/bin/afl-clang
	rm $(CURDIR)/debian/tmp/usr/bin/afl-clang++
	# insert correct version in helper-script
	sed -i "s|LLVM_MAJOR_VERSION|$(LLVM_MAJOR_VERSION)|" debian/helper-script/afl-clang
	sed -i "s|LLVM_MAJOR_VERSION|$(LLVM_MAJOR_VERSION)|" debian/helper-script/afl-clang++

override_dh_install:
	dh_install
ifneq "$(AFL_NO_X86)" ""
	# Keep only the *-fast* variants on non-x86
	cd debian/afl++/usr/lib/afl/ && rm as afl-as
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) test
endif

override_dh_gencontrol:
	dh_gencontrol -- -Vllvm-major-version=$(LLVM_MAJOR_VERSION)

override_dh_installdocs:
	dh_installdocs -A README.md -XINSTALL.md

override_dh_compress:
	dh_compress -X.c -X.mp4 -X.sql -XREADME -X.txt

# Exclude afl++-doc from many operations due to embedded binaries
override_dh_buildinfo:
	dh_buildinfo -Nafl++-doc

override_dh_strip_nondeterminism:
	# see #803503
	dh_strip_nondeterminism -Nafl++-doc

override_dh_strip:
	dh_strip -Nafl++-doc

override_dh_makeshlibs:
	dh_makeshlibs -Nafl++-doc

## aflplusplus 4.02c

=== debian/changelog ===
aflplusplus (4.02c-1ubuntu1) kinetic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Increase test-custom-mutators timeouts to avoid
      FTBFS on arm64 amd armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 12 Sep 2022 14:06:59 +0200

aflplusplus (4.02c-1) unstable; urgency=medium

  * New upstream version 4.02c
  * Switch to llvm-toolchain-14 (Closes: #1017655)
  * Do not run dh_dwz
  * Update lintian-overrides
  * Bump Standards-Version to 4.6.1 (no change)

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 08 Sep 2022 15:02:46 +0200

=== debian/control ===
--- 
+++ 
@@ -7,16 +7,16 @@
  Sophie Brun <sophie@offensive-security.com>,
  Raphaël Hertzog <raphael@offensive-security.com>
 Build-Depends:
- clang-13,
+ clang-14,
  debhelper-compat (= 13),
  dh-buildinfo,
  gcc-10-plugin-dev (>= 10.2.1-16),
- llvm-13-dev,
+ llvm-14-dev,
  python3-dev,
 # for the tests
  clang,
  libcmocka-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/vanhauser-thc/AFLplusplus
 Vcs-Git: https://salsa.debian.org/pkg-security-team/aflplusplus.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/aflplusplus

## aflplusplus 4.04c

=== qemu_mode/fastexit/Makefile ===
#
# american fuzzy lop++ - fastexit
# --------------------------------
#
# Written by Andrea Fioraldi <andreafioraldi@gmail.com>
#
# Copyright 2019-2022 Andrea Fioraldi. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

TARGETS=fastexit.so fastexit32.so fastexit64.so

all:  $(TARGETS)

fastexit.so: fastexit.c
	@if $(CC) -fPIC -shared fastexit.c -o fastexit.so 2>/dev/null ; then echo "fastexit build success"; else echo "fastexit build failure (that's fine)"; fi

fastexit32.so: fastexit.c
	@if $(CC) -fPIC -m32 -shared fastexit.c -o fastexit32.so 2>/dev/null ; then echo "fastexit32 build success"; else echo "fastexit32 build failure (that's fine)"; fi

fastexit64.so: fastexit.c
	@if $(CC) -fPIC -m64 -shared fastexit.c -o fastexit64.so 2>/dev/null ; then echo "fastexit64 build success"; else echo "fastexit64 build failure (that's fine)"; fi

clean:
	rm -f fastexit.so

=== qemu_mode/libcompcov/Makefile ===
#
# american fuzzy lop++ - libcompcov
# --------------------------------
#
# Written by Andrea Fioraldi <andreafioraldi@gmail.com>
#
# Copyright 2019-2022 Andrea Fioraldi. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#

PREFIX      ?= /usr/local
HELPER_PATH  = $(PREFIX)/lib/afl
DOC_PATH    ?= $(PREFIX)/share/doc/afl
MAN_PATH    ?= $(PREFIX)/share/man/man8

VERSION     = $(shell grep '^\#define VERSION ' ../config.h | cut -d '"' -f2)

CFLAGS      ?= -O3 -funroll-loops
CFLAGS      += -I ../../include/
CFLAGS      += -Wall -Wno-unused-result -D_FORTIFY_SOURCE=2 -g -Wno-pointer-sign
LDFLAGS     += -ldl

all: libcompcov.so

libcompcov.so: libcompcov.so.c ../../config.h
	$(CC) $(CFLAGS) -shared -fPIC $< -o ../../$@ $(LDFLAGS)

.NOTPARALLEL: clean

clean:
	rm -f *.o *.so *~ a.out core core.[1-9][0-9]*
	rm -f ../../libcompcov.so compcovtest

compcovtest:	compcovtest.cc
	$(CXX) -std=c++11 $< -o $@ 

install: all
	install -m 755 ../../libcompcov.so $${DESTDIR}$(HELPER_PATH)
	install -m 644 -T README.md $${DESTDIR}$(DOC_PATH)/README.compcov.md

=== qemu_mode/unsigaction/Makefile ===
--- 
+++ 
@@ -12,19 +12,19 @@
 #
 #   http://www.apache.org/licenses/LICENSE-2.0
 #
-.POSIX:
 
-_UNIQ=_QINU_
-
-TARGETCANDIDATES=unsigaction.so
-_TARGETS=$(_UNIQ)$(AFL_NO_X86)$(_UNIQ)
-__TARGETS=$(_TARGETS:$(_UNIQ)1$(_UNIQ)=)
-TARGETS=$(__TARGETS:$(_UNIQ)$(_UNIQ)=$(TARGETCANDIDATES))
+TARGETS=unsigaction.so unsigaction32.so unsigaction64.so
 
 all:  $(TARGETS)
 
 unsigaction.so: unsigaction.c
 	@if $(CC) -fPIC -shared unsigaction.c -o unsigaction.so 2>/dev/null ; then echo "unsigaction build success"; else echo "unsigaction build failure (that's fine)"; fi
 
+unsigaction32.so: unsigaction.c
+	@if $(CC) -fPIC -m32 -shared unsigaction.c -o unsigaction32.so 2>/dev/null ; then echo "unsigaction32 build success"; else echo "unsigaction32 build failure (that's fine)"; fi
+
+unsigaction64.so: unsigaction.c
+	@if $(CC) -fPIC -m64 -shared unsigaction.c -o unsigaction64.so 2>/dev/null ; then echo "unsigaction64 build success"; else echo "unsigaction64 build failure (that's fine)"; fi
+
 clean:
 	rm -f unsigaction.so

=== utils/libdislocator/Makefile ===
--- 
+++ 
@@ -19,9 +19,10 @@
 VERSION     = $(shell grep '^\#define VERSION ' ../../config.h | cut -d '"' -f2)
 
 CFLAGS      ?= -O3 -funroll-loops -D_FORTIFY_SOURCE=2
-override CFLAGS += -I ../../include/ -Wall -g -Wno-pointer-sign
+CFLAGS += -I ../../include/ -Wall -g -Wno-pointer-sign
 
 CFLAGS_ADD=$(USEHUGEPAGE:1=-DUSEHUGEPAGE)
+CFLAGS_ADD += $(USENAMEDPAGE:1=-DUSENAMEDPAGE)
 CFLAGS += $(CFLAGS_ADD)
 
 all: libdislocator.so

=== unicorn_mode/samples/speedtest/rust/Makefile ===
.PHONY: all fuzz

all: ../target ./target/release/unicornafl_harness

afl-fuzz: ../../../../afl-fuzz
../../../../afl-fuzz:
	$(MAKE) -C ../../../../ afl-fuzz

clean:
	cargo clean

./target/release/unicornafl_harness: ./src/main.rs
	cargo build --release

./target/debug/unicornafl_harness: ./src/main.rs
	cargo build

../target:
	$(MAKE) -C ..

fuzz: all afl-fuzz
	rm -rf ./output
	SKIP_BIN_CHECK=1 ../../../../afl-fuzz -s 1 -i ../sample_inputs -o ./output -- ./target/release/unicornafl_harness @@

=== debian/changelog ===
aflplusplus (4.04c-4) unstable; urgency=medium

  * Import a patch to fix CVE-2023-26266 (Closes: #1033255)

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 24 Mar 2023 11:29:28 +0100

aflplusplus (4.04c-3) unstable; urgency=medium

  * Disable lld support on s390x for now (Closes: #1026103). Thanks to
    Gianfranco Costamagna

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 23 Jan 2023 10:58:26 +0100

aflplusplus (4.04c-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Add missing build dependency on dh-strip-nondeterminism for command dh_strip_nondeterminism.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

  [ Sophie Brun ]
  * Add missing build-dep lld-14 (Closes: #1025443)
  * Disable download attempts during the build (Closes: #1025454)

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 05 Dec 2022 15:01:31 +0100

aflplusplus (4.04c-1) unstable; urgency=medium

  * New upstream version 4.04c
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 16 Nov 2022 10:41:42 +0100

aflplusplus (4.02c-2) unstable; urgency=medium

  * Do not ignore gcc plugin failures (Closes: #1023671)
  * Update build-dep to gcc-12-plugin-dev

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 15 Nov 2022 14:58:34 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: aflplusplus
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders:
  Sophie Brun <sophie@offensive-security.com>,
  Raphaël Hertzog <raphael@offensive-security.com>
@@ -10,12 +9,14 @@
  clang-14,
  debhelper-compat (= 13),
  dh-buildinfo,
- gcc-10-plugin-dev (>= 10.2.1-16),
+ gcc-12-plugin-dev,
+ lld-14 [!s390x],
  llvm-14-dev,
  python3-dev,
 # for the tests
  clang,
- libcmocka-dev
+ libcmocka-dev,
+ dh-strip-nondeterminism
 Standards-Version: 4.6.1
 Homepage: https://github.com/vanhauser-thc/AFLplusplus
 Vcs-Git: https://salsa.debian.org/pkg-security-team/aflplusplus.git

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 endif
 
 # Keep this in sync with Build-Depends (clang-X, llvm-X-dev)
-export LLVM_MAJOR_VERSION = 13
+export LLVM_MAJOR_VERSION = 14
 export LLVM_CONFIG = llvm-config-$(LLVM_MAJOR_VERSION)
 
 %:
@@ -67,4 +67,8 @@
 	dh_strip -Nafl++-doc
 
 override_dh_makeshlibs:
-	dh_makeshlibs -Nafl++-doc 
+	dh_makeshlibs -Nafl++-doc
+
+override_dh_dwz:
+	# do not run dh_dwz. Since clang 14 it fails with
+	# "Unknown debugging section .debug_addr"

## aflplusplus 4.08c

=== debian/changelog ===
aflplusplus (4.08c-1ubuntu2) mantic; urgency=medium

  * Ignore for now test failures on s390x, clang is flaky there.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 05 Sep 2023 20:15:45 +0200

aflplusplus (4.08c-1ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Increase test-custom-mutators timeouts to avoid
      FTBFS on arm64 and armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 20 Aug 2023 08:47:56 +0200

aflplusplus (4.08c-1) unstable; urgency=medium

  * gcc-mutlilib is not available on all arch (Closes: #1038760)
  * New upstream version 4.08c
  * Fix build with gcc 13 (Closes: #1037569)

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 18 Aug 2023 14:52:09 +0200

aflplusplus (4.07c-1ubuntu2) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - depend on gcc-multilib only on amd64 and s390x
    - Increase test-custom-mutators timeouts to avoid
      FTBFS on arm64 and armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 20 Jun 2023 22:46:27 +0200

aflplusplus (4.07c-1) unstable; urgency=medium

  * New upstream version 4.07c
  * Refresh patches
  * Add missing build-dep (Closes: #1034004)
  * Drop transitional packages (Closes: #1038213, #1038214, #1038215, #1038216)
  * Bump Standards-Version to 4.6.2 (no change)
  * Update debian/copyright

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 20 Jun 2023 15:24:12 +0200

aflplusplus (4.04c-4ubuntu1) lunar; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Increase test-custom-mutators timeouts to avoid
      FTBFS on arm64 and armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 Mar 2023 07:49:41 +0200

aflplusplus (4.04c-3ubuntu1) lunar; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Increase test-custom-mutators timeouts to avoid
      FTBFS on arm64 and armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Jan 2023 09:45:35 +0100

aflplusplus (4.04c-2ubuntu3) lunar; urgency=medium

  * No-change rebuild with Python 3.11 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 26 Dec 2022 09:46:30 +0000

aflplusplus (4.04c-2ubuntu2) lunar; urgency=medium

  * Disable lld support on s390x for now, making the build fail.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 21 Dec 2022 10:40:50 +0100

aflplusplus (4.04c-2ubuntu1) lunar; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Increase test-custom-mutators timeouts to avoid
      FTBFS on arm64 and armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 21 Dec 2022 10:21:02 +0100

aflplusplus (4.04c-1ubuntu1) lunar; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Increase test-custom-mutators timeouts to avoid
      FTBFS on arm64 and armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 18 Nov 2022 11:15:00 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,8 @@
  clang-14,
  debhelper-compat (= 13),
  dh-buildinfo,
- gcc-12-plugin-dev,
+ gcc-13-plugin-dev,
+ gcc-multilib [amd64 i386 mips64el mipsel ppc64 s390x sparc64 x32],
  lld-14 [!s390x],
  llvm-14-dev,
  python3-dev,
@@ -17,7 +18,7 @@
  clang,
  libcmocka-dev,
  dh-strip-nondeterminism
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/vanhauser-thc/AFLplusplus
 Vcs-Git: https://salsa.debian.org/pkg-security-team/aflplusplus.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/aflplusplus
@@ -49,18 +50,6 @@
  .
  afl++ is a fork of the unmaintained afl.
 
-Package: afl++-clang
-Architecture: any
-Section: oldlibs
-Depends: afl++,
-         ${misc:Depends}
-Recommends: afl++-doc
-Breaks: afl-clang (<< 2.53c)
-Replaces: afl-clang (<< 2.53c)
-Description: transitional dummy package for afl++-clang to afl++
- This is a transitional package. It can safely be removed once afl++ is
- installed.
-
 Package: afl++-doc
 Architecture: all
 Section: doc
@@ -74,27 +63,3 @@
  .
  This package provides the documentation, a collection of special crafted test
  cases, vulnerability samples and experimental stuff.
-
-Package: afl
-Architecture: all
-Section: oldlibs
-Depends: ${misc:Depends}, afl++
-Description: transitional dummy package for afl to afl++
- This is a transitional package. It can safely be removed once afl++ is
- installed.
-
-Package: afl-clang
-Architecture: all
-Section: oldlibs
-Depends: ${misc:Depends}, afl++-clang
-Description: transitional dummy package for afl-clang to afl++-clang
- This is a transitional package. It can safely be removed once afl++-clang is
- installed.
-
-Package: afl-doc
-Architecture: all
-Section: oldlibs
-Depends: ${misc:Depends}, afl++-doc
-Description: transitional dummy package for afl-doc to afl++-doc
- This is a transitional package. It can safely be removed once afl++-doc is
- installed.

=== debian/rules ===
--- 
+++ 
@@ -43,7 +43,11 @@
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+ifeq (s390x,$(DEB_HOST_ARCH))
+	$(MAKE) test || true
+else
 	$(MAKE) test
+endif
 endif
 
 override_dh_gencontrol:

## aflplusplus 4.09c

=== custom_mutators/autotokens/Makefile ===
ifdef debug
	CPPLAGS += -fsanitize=address
	CXXFLAGS += -Wall
	CC := clang
	CXX := clang++
endif
ifdef DEBUG
	CPPFLAGS += -fsanitize=address
	CXXFLAGS += -Wall
	CC := clang
	CXX := clang++
endif

all:	autotokens.so

afl-fuzz-queue.o:	../../src/afl-fuzz-queue.c
	$(CC) -D_STANDALONE_MODULE=1 -I../../include -g -O3 $(CPPFLAGS) -fPIC -c -o ./afl-fuzz-queue.o ../../src/afl-fuzz-queue.c

afl-common.o:	../../src/afl-common.c
	$(CC) -I../../include -g -O3 $(CPPFLAGS) -DBIN_PATH=\"dummy\" -Wno-pointer-sign -fPIC -c -o ./afl-common.o ../../src/afl-common.c

autotokens.so:	afl-fuzz-queue.o afl-common.o autotokens.cpp
	$(CXX) -Wno-deprecated -g -O3 $(CXXFLAGS) $(CPPFLAGS) -shared -fPIC -o autotokens.so -I../../include autotokens.cpp  ./afl-fuzz-queue.o ../../src/afl-performance.o ./afl-common.o

clean:
	rm -f autotokens.so *.o *~ core

=== custom_mutators/examples/Makefile ===
all: libexamplemutator.so

libexamplemutator.so:
	$(CC) $(CFLAGS) -D_FORTIFY_SOURCE=2 -O3 -fPIC -shared -g -I ../../include example.c -o libexamplemutator.so

clean:
	rm -rf libexamplemutator.so

=== custom_mutators/honggfuzz/Makefile ===

CFLAGS = -O3 -funroll-loops -fPIC -Wl,-Bsymbolic

all: honggfuzz-mutator.so

honggfuzz-mutator.so:	honggfuzz.c input.h mangle.c ../../src/afl-performance.c
	$(CC) $(CFLAGS) -I../../include -I. -shared -o honggfuzz-mutator.so honggfuzz.c mangle.c ../../src/afl-performance.c

update:
	@# seriously? --unlink is a dud option? sigh ...
	rm -f mangle.c mangle.h honggfuzz.h
	wget --unlink https://github.com/google/honggfuzz/raw/master/mangle.c
	wget --unlink https://github.com/google/honggfuzz/raw/master/mangle.h
	wget --unlink https://github.com/google/honggfuzz/raw/master/honggfuzz.h

clean:
	rm -f *.o *~ *.so core

=== custom_mutators/libafl_base/Makefile ===
all: target/release/liblibafl_base.so
	cp target/release/liblibafl_base.so libafl_base.so

target/release/liblibafl_base.so: src/lib.rs
	cargo build --release

clean:
	cargo clean
	rm -f libafl_base.so

=== qemu_mode/fastexit/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 #
 # Written by Andrea Fioraldi <andreafioraldi@gmail.com>
 #
-# Copyright 2019-2022 Andrea Fioraldi. All rights reserved.
+# Copyright 2019-2023 Andrea Fioraldi. All rights reserved.
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.

=== qemu_mode/libcompcov/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 #
 # Written by Andrea Fioraldi <andreafioraldi@gmail.com>
 #
-# Copyright 2019-2022 Andrea Fioraldi. All rights reserved.
+# Copyright 2019-2023 Andrea Fioraldi. All rights reserved.
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.

=== qemu_mode/libqasan/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 #
 # Written by Andrea Fioraldi <andreafioraldi@gmail.com>
 #
-# Copyright 2019-2022 Andrea Fioraldi. All rights reserved.
+# Copyright 2019-2023 Andrea Fioraldi. All rights reserved.
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.

=== qemu_mode/unsigaction/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 #
 # Written by Andrea Fioraldi <andreafioraldi@gmail.com>
 #
-# Copyright 2019-2022 Andrea Fioraldi. All rights reserved.
+# Copyright 2019-2023 Andrea Fioraldi. All rights reserved.
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.

=== utils/afl_untracer/Makefile ===
ifdef DEBUG
  OPT=-O0
else
  OPT=-O3
endif
SYS = $(shell uname -s)
DL =
ifeq "$(SYS)" "Linux"
    DL = -ldl
endif

all:	afl-untracer libtestinstr.so

afl-untracer:	afl-untracer.c
	$(CC) $(OPT) -I../../include -g -o afl-untracer afl-untracer.c $(DL)

libtestinstr.so:	libtestinstr.c
	$(CC) -g -O0 -fPIC -o libtestinstr.so -shared libtestinstr.c

clean:
	rm -f afl-untracer libtestinstr.so *~ core

=== utils/argv_fuzzing/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # american fuzzy lop++ - argvfuzz
 # --------------------------------
 #
-# Copyright 2019-2022 Kjell Braden <afflux@pentabarf.de>
+# Copyright 2019-2023 Kjell Braden <afflux@pentabarf.de>
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
@@ -11,7 +11,7 @@
 #   http://www.apache.org/licenses/LICENSE-2.0
 #
 
-.PHONY: all install clean
+.PHONY: all install clean argv_fuzz_persistent_demo argv_fuzz_demo demo
 
 PREFIX     ?= /usr/local
 BIN_PATH    = $(PREFIX)/bin
@@ -41,7 +41,7 @@
 ___M32FLAG=$(__M32FLAG:$(CC_IS_GCC)$(CC_IS_ARMCOMPILER)=-m32)
 M32FLAG=$(___M32FLAG)
 
-all: argvfuzz32.so argvfuzz64.so
+all: argvfuzz32.so argvfuzz64.so demo
 
 argvfuzz32.so: argvfuzz.c
 	-@$(CC) $(M32FLAG) $(CFLAGS) $^ $(LDFLAGS) -o $@ 2>/dev/null || echo "argvfuzz32 build failure (that's fine)"
@@ -54,5 +54,14 @@
 	if [ -f argvfuzz32.so ]; then set -e; install -m 755 argvfuzz32.so $(DESTDIR)$(HELPER_PATH)/; fi
 	if [ -f argvfuzz64.so ]; then set -e; install -m 755 argvfuzz64.so $(DESTDIR)$(HELPER_PATH)/; fi
 
+argv_fuzz_persistent_demo: argv_fuzz_persistent_demo.c
+	../../afl-cc -g -o $@ $^
+
+argv_fuzz_demo: argv_fuzz_demo.c
+	../../afl-cc -g -o $@ $^
+
+demo: argv_fuzz_persistent_demo argv_fuzz_demo
+
 clean:
-	rm -f argvfuzz32.so argvfuzz64.so
+	rm -f argvfuzz32.so argvfuzz64.so argv_fuzz_demo argv_fuzz_persistent_demo
+

=== utils/persistent_mode/Makefile ===
all:
	../../afl-clang-fast -o persistent_demo persistent_demo.c
	../../afl-clang-fast -o persistent_demo_new persistent_demo_new.c
	AFL_DONT_OPTIMIZE=1 ../../afl-clang-fast -o test-instr test-instr.c

document:
	AFL_DONT_OPTIMIZE=1 ../../afl-clang-fast -D_AFL_DOCUMENT_MUTATIONS -o test-instr test-instr.c

clean:
	rm -f persistent_demo persistent_demo_new test-instr

=== utils/qemu_persistent_hook/Makefile ===
all:
	$(CC) -no-pie test.c -o test
	$(CC) -fPIC -shared read_into_rdi.c -o read_into_rdi.so

clean:
	rm -rf in out test read_into_rdi.so

=== debian/changelog ===
aflplusplus (4.09c-1ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:05:14 +1100

aflplusplus (4.09c-1ubuntu2) noble; urgency=high

  * No change rebuild against libpython3.12t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 16:48:15 +0100

aflplusplus (4.09c-1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Increase test-custom-mutators timeouts to avoid
      FTBFS on arm64 and armhf
    - Ignore for now test failures on s390x, clang is flaky there.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 25 Jan 2024 09:52:12 +0100

aflplusplus (4.09c-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Repository.

  [ Sophie Brun ]
  * New upstream version 4.09c (Closes: #1053679)
  * Upgrade to llvm-toolchain 17 (Closes: #1061209)
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 24 Jan 2024 14:33:34 +0100

aflplusplus (4.08c-1ubuntu3) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 20 Jan 2024 08:36:36 +0000

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,19 @@
 Source: aflplusplus
 Section: devel
 Priority: optional
-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders:
  Sophie Brun <sophie@offensive-security.com>,
  Raphaël Hertzog <raphael@offensive-security.com>
 Build-Depends:
- clang-14,
+ clang-17,
  debhelper-compat (= 13),
  dh-buildinfo,
  gcc-13-plugin-dev,
  gcc-multilib [amd64 i386 mips64el mipsel ppc64 s390x sparc64 x32],
- lld-14 [!s390x],
- llvm-14-dev,
+ lld-17 [!s390x],
+ llvm-17-dev,
  python3-dev,
 # for the tests
  clang,

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 endif
 
 # Keep this in sync with Build-Depends (clang-X, llvm-X-dev)
-export LLVM_MAJOR_VERSION = 14
+export LLVM_MAJOR_VERSION = 17
 export LLVM_CONFIG = llvm-config-$(LLVM_MAJOR_VERSION)
 
 %:

## aflplusplus 4.20c

=== debian/changelog ===
aflplusplus (4.20c-6) unstable; urgency=medium

  * Another patch that should fix the s390x tests

 -- Arnaud Rebillout <arnaudr@kali.org>  Thu, 16 May 2024 15:36:13 +0700

aflplusplus (4.20c-5) unstable; urgency=medium

  * Revert "test-llvm: Fuzz for 60 seconds (was 30)"
  * Add patch to fix test suite for good (?)

 -- Arnaud Rebillout <arnaudr@kali.org>  Tue, 14 May 2024 22:41:03 +0700

aflplusplus (4.20c-4) unstable; urgency=medium

  * test-llvm: Fuzz for 60 seconds (was 30)

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 13 May 2024 10:00:05 +0700

aflplusplus (4.20c-3) unstable; urgency=medium

  * Add patch to re-enable afl-cc for i386

 -- Arnaud Rebillout <arnaudr@kali.org>  Sat, 11 May 2024 14:57:50 +0700

aflplusplus (4.20c-2) unstable; urgency=medium

  * Cherry-pick upstream patches to fix afl-gcc

 -- Arnaud Rebillout <arnaudr@kali.org>  Wed, 17 Apr 2024 20:41:05 +0700

aflplusplus (4.20c-1) unstable; urgency=medium

  * Update upstream url
  * New upstream version 4.20c
  * Refresh patches

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 15 Apr 2024 16:00:18 +0700

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: aflplusplus
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders:
  Sophie Brun <sophie@offensive-security.com>,
  Raphaël Hertzog <raphael@offensive-security.com>
@@ -20,7 +19,7 @@
  libcmocka-dev,
  dh-strip-nondeterminism
 Standards-Version: 4.6.2
-Homepage: https://github.com/vanhauser-thc/AFLplusplus
+Homepage: https://github.com/AFLplusplus/AFLplusplus
 Vcs-Git: https://salsa.debian.org/pkg-security-team/aflplusplus.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/aflplusplus
